%format movie_lens dataset

clear all;clc;
filename='../../Dataset&Code/data_movielens/ml-1m/ratings.dat';
fileID = fopen(filename,'r');
formatSpec = '%d::%d::%d::%d';%format: 1::1193::5::978300760  %UserID::MovieID::Rating::Timestamp
sizeA = [4 Inf];
Ratings = fscanf(fileID,formatSpec,sizeA);%populates data in column order
fclose(fileID);
UM=zeros(max(Ratings(1,:)),max(Ratings(2,:)),'uint8');%User--Movie
for index_r=1:size(Ratings,2)
    UM(Ratings(1,index_r),Ratings(2,index_r))=Ratings(3,index_r);
end

filename='../../Dataset&Code/data_movielens/ml-1m/users_FMr.dat';
Ages=containers.Map(...
{1 18 25 35 45 50 56},...
{ ...
    '1:  "Under 18"', ...
    '18:  "18-24"', ...
    '25:  "25-34"', ...
    '35:  "35-44"', ...
    '45:  "45-49"', ...
    '50:  "50-55"', ...
    '56:  "56+"'});
Occupations=containers.Map(...
    { 0     1     2     3     4     5     6     7     8     9    10    11    12    13    14   15    16    17    18    19    20},...
    {'0:  "other" or not specified',...
	'1:  "academic/educator"',...
	'2:  "artist"',...
	'3:  "clerical/admin"',...
	'4:  "college/grad student"',...
	'5:  "customer service"',...
	'6:  "doctor/health care"',...
	'7:  "executive/managerial"',...
	'8:  "farmer"',...
	'9:  "homemaker"',...
	'10:  "K-12 student"',...
	'11:  "lawyer"',...
	'12:  "programmer"',...
	'13:  "retired"',...
	'14:  "sales/marketing"',...
	'15:  "scientist"',...
	'16:  "self-employed"',...
	'17:  "technician/engineer"',...
	'18:  "tradesman/craftsman"',...
	'19:  "unemployed"',...
	'20:  "writer"'});
fileID = fopen(filename,'r');
formatSpec = '%d::%d::%d::%d::%d';%format: 1::F::1::10::48067  %UserID::Gender::Age::Occupation::Zip-code
sizeA = [5 Inf];
Users = fscanf(fileID,formatSpec,sizeA);%populates data in column order
fclose(fileID);

Genres = containers.Map(...
    {'Action'...
	'Adventure'...
	'Animation'...
	'Children''s'...
	'Comedy'...
	'Crime'...
	'Documentary'...
	'Drama'...
	'Fantasy'...
	'Film-Noir'...
	'Horror'...
	'Musical'...
	'Mystery'...
	'Romance'...
	'Sci-Fi'...
	'Thriller'...
	'War'...
	'Western'},...    
    {2     3     4     5     6     7     8     9    10    11    12    13    14   15    16    17	18  19});
filename='../../Dataset&Code/data_movielens/ml-1m/movies.dat';
Movies_str=[];
fileID = fopen(filename,'r');
tline = fgetl(fileID);
while ischar(tline) 
    key=sscanf(tline,'%d');
    Movies_str{key}=tline;
    tline = fgetl(fileID);
end
fclose(fileID);

Movies=zeros(19,size(Movies_str,2));%ID, then 18 columns of genres
for index_i=1:size(Movies_str,2)
    str_temp=Movies_str{index_i};
    idx = strfind(str_temp, '::');
    if isempty(idx)
        continue;
    end
    Movies(1,index_i) = index_i;
    C = strsplit(str_temp(idx(2)+2:end),'|');
    for index_j=1:size(C,2)
        Movies(cell2mat(values(Genres,C(index_j))),index_i) = 1;
    end
end


save movie_lens_1m.mat UM Ratings Users Ages Occupations Movies_str Movies
clear all;

load movie_lens_1m.mat
%get subdataset

submovies=[4 6 8];%'Animation'...'Comedy'...'Documentary'...
subusers=[1 25 56];
UM=zeros(max(Ratings(1,:)),max(Ratings(2,:)),'uint8');%User--Movie
for index_r=1:size(Ratings,2)
    if sum( Movies(submovies,Ratings(2,index_r)))>0 && sum( subusers == Users(3,Ratings(1,index_r)) )>0
        UM(Ratings(1,index_r),Ratings(2,index_r))=Ratings(3,index_r);
    end
end
idx_del=[];
for index_i=1:size(UM,1)
    if sum(UM(index_i,:))==0
        idx_del=[idx_del index_i];
    end
end
UM(idx_del,:)=[];
idx_del=[];
for index_i=1:size(UM,2)
    if sum(UM(:,index_i))==0
        idx_del=[idx_del index_i];
    end
end
UM(:,idx_del)=[];

save movielens_3x3.mat UM




